/*
 * Copyright (C) 2004 Robert Hogan <robert at roberthogan dot net>
 */

#ifndef _ABOUTKLAMAV_H_
#define _ABOUTKLAMAV_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <tdeapplication.h>
#include <tdemainwindow.h>



class KPrinter;
class TDEToggleAction;
class KURL;
class TQLineEdit;
class TQComboBox;
class TQCheckBox;
class TQListBox;
class TQPushButton;
class TQLabel;
class TDEProcess;
class TDEConfig;
class KURLRequester;

namespace KlamAV
{
    class TabWidget;
    class PageViewer;
}


/**
 * This class serves as the main window for Aboutklamav.  It handles the
 * menus, toolbars, and status bars.
 *
 * @short Main window class
 * @author $AUTHOR <$EMAIL>
 * @version $APP_VERSION
 */
class Aboutklamav :  public TQWidget
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    Aboutklamav(TQWidget *parent, const char *name=0);

    /**
     * Default Destructor
     */
    virtual ~Aboutklamav();

    /**
     * Use this method to load whatever file/URL you have
     */
    void load(const KURL& url);
    void  setDirName(TQString);

protected:
    /**
     * Overridden virtuals for TQt drag 'n drop (XDND)
     */
    /*virtual void dragEnterEvent(TQDragEnterEvent *event);
    virtual void dropEvent(TQDropEvent *event);*/

protected:
    /**
     * This function is called when it is time for the app to save its
     * properties for session management purposes.
     */
    //void saveProperties(TDEConfig *);

    /**
     * This function is called when this app is restored.  The TDEConfig
     * object points to the session management config file that was saved
     * with @ref saveProperties
     */
    //void readProperties(TDEConfig *);


private slots:
/*    void fileNew();
    void fileOpen();
    void fileSave();
    void fileSaveAs();
    void filePrint();
    void optionsShowToolbar();
    void optionsShowStatusbar();
    void optionsConfigureKeys();
    void optionsConfigureToolbars();
    void optionsPreferences();
    void newToolbarConfig();
*/
    //void changeStatusbar(const TQString& text);
    //void changeCaption(const TQString& text);

private:
    void setupAccel();
    void setupActions();

private:
    //AboutklamavView *m_view;

  /*  KPrinter   *m_printer;
    TDEToggleAction *m_toolbarAction;
    TDEToggleAction *m_statusbarAction;*/
    KlamAV::PageViewer* homepage;
    KlamAV::TabWidget* tabBrowser;
signals:
    void itemSelected(TQString abs_filename, int line);

public slots:

private slots:

protected slots:
            void slotOpenTabPlain(const KURL& url, bool background = false);
            void slotTabCaption(const TQString &capt);

private:

    TQPushButton *about_button;
    TDEConfig *config;
    TQComboBox *check_combo;
    TQLabel *notes_label;
};

#endif // _Aboutklamav_H_
